/*   
TPWC AI SUPPRESSION   

Authors: TPW && -Coulum- && Fabrizio_T  
Additional code: Ollem  
Version: 2.00beta 
Last modified: 20120702
Requires: CBA
Disclaimer: Feel free to use and modify this code, on the proviso that you post back changes and improvements so that everyone can benefit from them, and acknowledge the original authors in any derivative works.
*/   

///////////
//VARIABLES
///////////

//DELAY BEFORE SUPPRESSION FUNCTIONS START. ALLOWS TIME FOR OTHER AI MODS TO SET UNIT SKILLS
tpwcas_sleep = 2;

//DEBUGGING. WILL DISPLAY RED BALLS OVER ANY SUPPRESSED UNITS. SET TO 1 FOR DEBUGGING
tpwcas_debug = 1;

//BULLET IGNORE RADIUS (M). BULLETS FROM A SHOOTER CLOSER THAN THIS WILL NOT SUPPRESS. 
tpwcas_ir = 25;

//SHOT THRESHOLD. MORE SHOTS THAN THIS WILL CAUSE UNIT TO DROP/CRAWL
tpwcas_st = 15;

//STARTUP HINT 0 = NO HINT, 1 = HINT
tpwcas_hint = 1;

//PLAYER SUPPRESSION SHAKE. 0 = NO SUPPRESSION, 1 = SUPPRESSION    
tpwcas_playershake = 1;

//PLAYER SUPPRESSION VISUALS. 0 = NO SUPPRESSION, 1 = SUPPRESSION    
tpwcas_playervis = 1;

//PISTOL AND SMG AMMO TO IGNORE. ADD CUSTOM AMMO (EG SUPPRESSED) OR CHANGE TO TASTE.  
tpwcas_mags =  
[  
"30rnd_9x19_MP5",     
"30rnd_9x19_MP5SD",     
"15Rnd_9x19_M9",     
"15Rnd_9x19_M9SD",     
"7Rnd_45ACP_1911",     
"7Rnd_45ACP_1911",    
"8Rnd_9x18_Makarov",    
"8Rnd_9x18_MakarovSD",    
"64Rnd_9x19_Bizon",    
"64Rnd_9x19_SD_Bizon",    
"13Rnd_9mm_SLP",    
"17Rnd_9x19_glock17",    
"6Rnd_45ACP",    
"30Rnd_9x19_UZI",    
"30Rnd_9x19_UZI_SD"  
]; 

//////////  
//SET UP   
//////////  

//DECLARE PRIVATE VARIABLES   
private ["_stanceregain","_skillregain","_unit","_bc","_shots","_originalaccuracy","_originalshake","_originalcourage","_general","_ball","_ball1","_ball2","_ball3","_skillset","_asr","_tint","_blur","_x","_ppmod","_ppmodifier"];

//INITIAL FILTERED UNIT ARRAY = ALL UNITS
tpwcas_filtered_units = allunits;

//WAIT
sleep tpwcas_sleep;   

//START HINT      
if (tpwcas_hint == 1) then {   
0 = [] spawn {  
hintsilent "TPWC AI Suppress 2.00beta Active";   
sleep 3;   
hintsilent ""};   
};


////////////
//FUNCTIONS
////////////

tpwcas_fnc_main_loop =
{  
while {true} do   
    {  
	tpwcas_supvisflag = 0;  
        {  
		_unit  = _x; 
		_stanceregain = _unit getvariable ["tpwcas_stanceregain", -1]; 
				 
		//SET INITIAL PARAMETERS FOR EACH UNIT  
		if (_stanceregain == -1) then       
			{   
			_unit setvariable ["asr_ai_sys_aiskill_configured", false];    
			_unit setvariable ["tpwcas_skillset", false];
			_unit setvariable ["tpwcas_originalaccuracy", _unit skill "aimingaccuracy"];     
			_unit setvariable ["tpwcas_originalshake",  _unit skill "aimingshake"];    
			_unit setvariable ["tpwcas_originalcourage", _unit skill "courage"];     
			_unit setvariable ["tpwcas_general", _unit skill "general"];    
			_unit setvariable ["tpwcas_stanceregain", diag_ticktime];     
			_unit setvariable ["tpwcas_skillregain", diag_ticktime];   
				
			//SET UP COLOURED DEBUGGING BALLS
			if (tpwcas_debug == 1) then     
				{ 
				_ball1 = "Sign_sphere25cm_EP1" createvehicle getposatl _unit;  
				_ball1 setObjectTexture [0,"#(argb,8,8,3)color(0.2,0.9,0.2,0.5,ca)"];  
				_ball1 attachTo [_unit,[0,0,2]];   
				_unit setvariable ["tpwcas_sup1ball",_ball1]; 
				_ball1 hideobject true;  
									  
				_ball2 = "Sign_sphere25cm_EP1" createvehicle getposatl _unit;  
				_ball2 setObjectTexture [0,"#(argb,8,8,3)color(0.6,0.9,0.0,0.7,ca)"]; //yellow  
				_ball2 attachTo [_unit,[0,0,2]];   
				_unit setvariable ["tpwcas_sup2ball",_ball2]; 
				_ball2 hideobject true;  
				  
				_ball3 = "Sign_sphere25cm_EP1" createvehicle getposatl _unit;  
				_ball3 setObjectTexture [0,"#(argb,8,8,3)color(0.8,0.5,0.5,0.5,ca)"]; //red  
				_ball3 attachTo [_unit,[0,0,2]];   
				_unit setvariable ["tpwcas_sup3ball",_ball3]; 
				_ball3 hideobject true;                       
				};  
			};   
		
		//IF UNIT SKILLS ARE UNSUPPRESSED  
		if (diag_ticktime >= _skillregain) then      
			{  
			_originalaccuracy = _unit getvariable "tpwcas_originalaccuracy";        
			_originalshake = _unit getvariable "tpwcas_originalshake";                 
			_originalcourage = _unit getvariable "tpwcas_originalcourage";     
			_general = _unit getvariable "tpwcas_general";           
			//GRADUAL RETURN OF ACCURACY
			if((_unit skill "aimingaccuracy") < _originalaccuracy) then      
				{    
				_unit setskill ["aimingaccuracy",(_unit skill "aimingaccuracy")+((_originalaccuracy-(_unit skill "aimingaccuracy"))*.325)];       
				};    
			//GRADUAL REDUCTION OF SHAKE	
			if((_unit skill "aimingshake") < _originalshake) then      
				{      
				_unit setskill ["aimingshake",(_unit skill "aimingshake")+((_originalshake-(_unit skill "aimingshake"))*.325)];      
				}; 
			//BACK TO NORMAL	
			if 	(((_unit skill "aimingshake") > (_originalshake - 0.05)) &&	((_unit skill "aimingaccuracy") > (_originalaccuracy - 0.05))) then 
				{
				_unit setskill ["aimingshake",_originalshake];
				_unit setskill ["aimingaccuracy",_originalaccuracy];
				_unit setvariable ["tpwcas_skillregain", diag_ticktime + 10];
				};	
			}; 
		
		//IF UNIT STANCE IS UNSUPPRESSED  
		if ( diag_ticktime >= _stanceregain) then       
			{
			_unit setunitpos "auto";					
			_unit setvariable ["tpwcas_supstate",0]; 
			_unit setvariable ["tpwcas_bc",0];	
			_unit setvariable ["tpwcas_ebc",0];
			
			//GRADUAL RETURN OF COURAGE
			_originalcourage = _unit getvariable "tpwcas_originalcourage";     
			_general = _unit getvariable "tpwcas_general"; 
			if((_unit skill "courage") < (_originalcourage - 0.05)) then      
				{      
				_unit setskill ["courage",(_unit skill "courage")+(_general)*(0.1)];       
				}     
				else
				{
				//BACK TO NORMAL
				_unit setskill ["courage",_originalcourage];
				_unit setvariable ["tpwcas_stanceregain", diag_ticktime + 10];
				};	
			};  
				
		//UNIT CHANGES FOR DIFFERENT SUPPRESSION
		switch ( _unit getvariable "tpwcas_supstate" ) do 
			{ 
			case 1: //IF ANY BULLETS NEAR UNIT 
				{ 
				//CROUCH IF NOT PRONE
				if ((_unit call CBA_fnc_getunitanim) select 0 != "prone") then 
					{
					_unit setunitpos "middle";	
					};
				}; 
			 
			case 2: //IF ENEMY BULLETS NEAR UNIT 
				{
				//CROUCH IF NOT PRONE
				if ((_unit call CBA_fnc_getunitanim) select 0 != "prone") then 
					{
					_unit setunitpos "middle";	
					};
				//SKILL MODIFICATION
				_originalaccuracy = _unit getvariable "tpwcas_originalaccuracy";       
				_originalshake = _unit getvariable "tpwcas_originalshake";     
				_originalcourage = _unit getvariable "tpwcas_originalcourage";      
				_general = _unit getvariable "tpwcas_general";    
				_shots = _unit getvariable "tpwcas_supshots";    
				_unit setskill ["aimingaccuracy",_originalaccuracy*_originalcourage*_general-(_shots*(1-_general)*.001)];        
				_unit setskill ["aimingshake",_originalshake*_originalcourage*_general-(_shots*(1-_general)*.001)];       
				_unit setskill ["courage",(_unit skill "courage")-(_shots*(1-_general)*(1-_originalcourage)*.02)];   
				//PLAYER CAMERA SHAKE 
				if ((isplayer unit) && (tpwcas_playershake == 1)) then   
					{   
					addCamShake [1.5 - (skill player),(random 4)-((_unit getvariable "tpwcas_general")+(_unit getvariable "tpwcas_originalcourage")) , 2.5]  
					};	
				}; 
			 
			case 3: //IF UNIT IS SUPPRESSED WITH MORE THAN 5 ENEMY BULLETS  
				{
				//GO PRONE
				_unit setunitpos "down";	
				_unit forcespeed -1; 
				//SKILL MODIFICATION
				_originalaccuracy = _unit getvariable "tpwcas_originalaccuracy";       
				_originalshake = _unit getvariable "tpwcas_originalshake";     
				_originalcourage = _unit getvariable "tpwcas_originalcourage";      
				_general = _unit getvariable "tpwcas_general";    
				_shots = _unit getvariable "tpwcas_supshots";
				_unit setskill ["aimingaccuracy",_originalaccuracy*_originalcourage*_general-(_shots*(1-_general)*.001)];        
				_unit setskill ["aimingshake",_originalshake*_originalcourage*_general-(_shots*(1-_general)*.001)];       
				_unit setskill ["courage",(_unit skill "courage")-(_shots*(1-_general)*(1-_originalcourage)*.02)];   
				//PLAYER CAMERA SHAKE AND FX
				if (isplayer _unit) then    
					{  
					if (tpwcas_playershake == 1) then 
						{
						addCamShake [2 - (skill _unit),(random 6)-((_unit getvariable "tpwcas_general")+(_unit getvariable "tpwcas_originalcourage")) , 5]  
						};
					if (tpwcas_playervis == 1) then 
						{	
						[] spawn tpwcas_fnc_visuals;  
						};
					};  
				};
			}; 
		} foreach tpwcas_filtered_units;
	sleep 1.5; 	
	};  
};  

//UNIT FILTER
tpwcas_filter = 
{
while {true} do
	{
	tpwcas_filtered_units = [];
		{
		if 
		(
		(vehicle _x == _x) && 
		(lifestate _x == "ALIVE") && 
		(side _x != civilian) && 
		(_x distance player < 1000)
		) then
			{
			tpwcas_filtered_units set [count tpwcas_filtered_units,_x]
			};
		} foreach allunits;
	sleep 10;
	};
};


//DEBUG BALL HANDLING LOOP  
tpwcas_fnc_ballhandler =
{
while {true} do 
	{
		{
		_unit = _x;
		//DISPLAY OR HIDE DEBUG BALLS AS APPROPRIATE	
		_ball1 = _unit getvariable "tpwcas_sup1ball";   
		_ball2 = _unit getvariable "tpwcas_sup2ball";   
		_ball3 = _unit getvariable "tpwcas_sup3ball";  
		 
		switch ( _unit getvariable "tpwcas_supstate" ) do 
			{ 
			case 1:  
				{ 
				tpwcas_ballstatus = [_ball1,false,_ball2,true,_ball3,true]; 
				}; 
			case 2: 
				{ 
				tpwcas_ballstatus = [_ball1,true,_ball2,false,_ball3,true]; 
				}; 
			case 3: 
				{ 
				tpwcas_ballstatus = [_ball1,true,_ball2,true,_ball3,false]; 
				}; 
			default 
				{ 
				tpwcas_ballstatus = [_ball1,true,_ball2,true,_ball3,true]; 
				}; 
			}; 
			
		if (lifestate _unit != "ALIVE") then 
			{
			tpwcas_ballstatus = [_ball1,true,_ball2,true,_ball3,true]; 
			};	
			
		tpwcas_ballstatus call 
		{
		(_this select 0) hideobject (_this select 1);
		(_this select 2) hideobject (_this select 3);
		(_this select 4) hideobject (_this select 5);
		};
		 
		if ( isDedicated ) then 
			{ 
			[-1, {(_this select 0) hideobject (_this select 1);(_this select 2) hideobject (_this select 3);(_this select 4) hideobject (_this select 5);}, tpwcas_ballstatus] call CBA_fnc_globalExecute; 
			}; 
		} foreach allunits;
 	
		//REMOVE DEBUG BALLS FROM DEAD AI  
		{  
		_unit = _x;  
		_ball1 = _unit getvariable "tpwcas_sup1ball";  
		if ( !(_ball1 == objNull) ) then   
			{    
			detach _ball1;   
			deleteVehicle _ball1;  
			_unit setvariable ["tpwcas_sup1ball",nil];          
			};  
			_ball2 = _unit getvariable "tpwcas_sup2ball";  
		if ( !(_ball2 == objNull) ) then   
			{    
			detach _ball2;   
			deleteVehicle _ball2;  
			_unit setvariable ["tpwcas_sup2ball",nil];          
			};  
			_ball3 = _unit getvariable "tpwcas_sup3ball";  
		if ( !(_ball3 == objNull) ) then   
			{    
			detach _ball3;   
			deleteVehicle _ball3;  
			_unit setvariable ["tpwcas_sup3ball",nil];          
			};  
		} foreach allDead; 
	sleep 2;	
	};		
};  
  
  
//BLUR PLAYER VISION WHEN SUPPRESSED  
tpwcas_fnc_visuals =   
{ 
if (tpwcas_supvisflag == 0) then   
    { 
	tpwcas_supvisflag = 1;  	
	_tint = ppEffectCreate ["Colorcorrections", 1552];  
    _tint ppEffectEnable true;  
    _blur = ppEffectCreate ["RadialBlur", 1551];  
    _blur ppEffectEnable true;  
	_ppmodifier = 0.001;
	
		{
		_ppmod = _ppmodifier * _x;
		_blur ppEffectAdjust [_ppmod,_ppmod,0.1,0.1]; 
		_blur ppEffectCommit 0; 
		_tint ppEffectAdjust[1, 1, (-5 * _ppmod), [0,0,0,0], [0,0,0,1], [0,0,0,1]];
		_tint ppEffectCommit 0; 
		sleep 0.1; 	
		} foreach [1,2,3,4,5];
    
	sleep 5;  

		{
		_ppmod = _ppmodifier * _x;
		_blur ppEffectAdjust [_ppmod,_ppmod,0.1,0.1]; 
		_blur ppEffectCommit 0; 
		_tint ppEffectAdjust[1, 1, (-5 * _ppmod), [0,0,0,0], [0,0,0,1], [0,0,0,1]];
		_tint ppEffectCommit 0; 
		sleep 0.1; 	
		} foreach [5,4,3,2,1]; 
    
	ppEffectDestroy _blur;  
    ppEffectDestroy _tint;  
    tpwcas_supvisflag = 0;  
    };  
};  


//IF ASR AI HAS SET UNIT SKILLS, MAKE THESE THE "ORIGINALS" FOR EACH UNIT    
tpwcas_fnc_asrskills =   
{   
sleep 3;   
while {true} do    
    {   
        {   
        _unit = _x;   
        _asr = _unit getVariable "asr_ai_sys_aiskill_configured";   
        _skillset = _unit getVariable "tpwcas_skillset";   
        if ((_asr) && !(_skillset))then    
            {   
            _unit setvariable ["tpwcas_originalaccuracy", _unit skill "aimingaccuracy"];     
            _unit setvariable ["tpwcas_originalshake", _unit skill "aimingshake"];    
            _unit setvariable ["tpwcas_originalcourage", _unit skill "courage"];     
            _unit setvariable ["tpwcas_general",_unit skill "general"];    
            _unit setvariable ["tpwcas_skillset", true];   
            };   
        } foreach allunits;   
    sleep 30;   
    };   
};    


//HOOK INTO BDETECT TO ADD TO EACH UNIT'S LOCAL BULLET COUNT AND SUPPRESSION STATUS
tpwcas_fnc_localbullets = 
{
private [ "_unit", "_distance", "_data", "_shooter","_shooterdistance","_shooterside"];
_unit = _this select 0; //suppressed unit
_distance = _this select 1; //distance of bullet from unit
_data = _this select 2; //
_shooter = _data select 0; //shooter
_shooterdistance = _shooter distance _unit; //distance of shooter from unit
_shooterside = side _shooter; //side of shooter
_bc = _unit getvariable "tpwcas_bc"; //total bullet count
_ebc = _unit getvariable "tpwcas_ebc"; //enemy bullet count
if (_shooterdistance >= tpwcas_ir) then 
	{
	_bc = _bc + 1;
	_unit setvariable ["tpwcas_skillregain", diag_ticktime + 2 + random 3];       
	_unit setvariable ["tpwcas_stanceregain", diag_ticktime + 5 + random 5];  
	_unit setvariable ["tpwcas_bc", _bc];
	_unit setvariable ["tpwcas_supstate",1];
	if (_shooterside getFriend ( side _unit) < 0.6 ) then 
		{
		_ebc = _ebc + 1;
		_unit setvariable ["tpwcas_ebc", _ebc];
		_unit reveal [_shooter, 3];
		};
	if (_ebc > 0) then 
		{
		_unit setvariable ["tpwcas_supstate",2];
		};
	if (_ebc > tpwcas_st) then 
		{
		_unit setvariable ["tpwcas_supstate",3];
		};		
	};
};


//CALL FABRIZIO_T'S BULLET DETECTION SYSTEM
call compile preprocessFileLineNumbers "\TPWC_AI_SUPPRESS_200\bdetect.sqf";
bdetect_skip_mags = tpwcas_mags;
bdetect_debug_enable = true;
bdetect_callback = "tpwcas_fnc_localbullets";
call bdetect_fnc_init;

//RUN THE REST
[] spawn tpwcas_fnc_filter;
[] spawn tpwcas_fnc_main_loop;
if (tpwcas_debug == 1) then     
	{
	[] spawn tpwcas_fnc_ballhandler;
	};